<?php 
	require_once('../../../wp-load.php');
 	$sanalposAyarlari = get_option("woocommerce_mobilexpress_settings");
	
 	$data = file_get_contents("php://input");
	
 	  
	  if(!empty($data)){
  	 	
		$result = json_decode($data,true);
 		
		$orderId = $result["processInfo"]["orderId"];
		$orderId = end(explode("_",$orderId));
		$order = new WC_Order($orderId);
		$order->add_order_note( "IPN Detayları: <br>".$data );
		
		$fraudControlResult = array();
		$fraudControl = false;
		foreach($result["paymentList"] as $paymentList){
	  		if(isset($paymentList["fraudControlInfo"]["fraudControlResult"])){
				$fraudControlResult[] = $paymentList["fraudControlInfo"]["fraudControlResult"];
				$fraudControl = true;
			}
		}
	
	$statuses = array();
	$statuses[] = $sanalposAyarlari['ipnBasariliSiparisDurumu'];
	$statuses[] = $sanalposAyarlari['ipnBasarisizSiparisDurumu'];
	
	$get_status = 'wc-' . $order->get_status( 'edit' );
	
	if(!in_array($get_status,$statuses)){
 		
			if(in_array("RiskNotDetected",$fraudControlResult)){
				$order->update_status($sanalposAyarlari['ipnBasariliSiparisDurumu']);
			}elseif(in_array("RiskDetected",$fraudControlResult)){
				$order->add_order_note( "ÖDEME GÜVENLİK KONTROLÜNDEN GEÇEMEDİ. (FRAUD İPTALİ)");
				$order->update_status($sanalposAyarlari['ipnBasarisizSiparisDurumu']);
			}elseif(in_array("InProcess",$fraudControlResult)){
				$order->add_order_note( "FRAUD KONTROLÜ DEVAM EDİYOR.");
				$order->update_status($sanalposAyarlari['siparisDurumu']);
			}elseif(in_array("NotProcessed",$fraudControlResult)){
				if($result["paymentResult"] == "Success"){
					$order->update_status($sanalposAyarlari['ipnBasariliSiparisDurumu']);
				}
			}else{
				if(!$fraudControl){
					if($result["paymentResult"] == "Success"){
						$order->update_status($sanalposAyarlari['ipnBasariliSiparisDurumu']);
						$order->add_order_note( "ÖDEMENİZ BAŞARILI OLMUŞTUR.");
					}
				}
			}
		}
	  }
 	 	die("OK");
?>