<?php 
	
	require_once('../../../wp-load.php');

	$orderid = end(explode("_",$_GET["OrderId"]));
	$order = new WC_Order($orderid);
	$checkout_payment_url = $order->get_checkout_payment_url(true);
	
	$sanalposAyarlari = get_option("woocommerce_mobilexpress_settings");
	
	$OrderId = $_GET["OrderId"];
		
	if(isset($_GET["SystemTransId"])){
		$SystemTransId = $_GET["SystemTransId"];
		$data = array(
				  "systemTransId"=> $SystemTransId,
				  "orderId"=> $OrderId,
				  "clientIp"=> getenv('REMOTE_ADDR'),
				  "clientUserAgent"=> $_SERVER['HTTP_USER_AGENT'],
				);
		$status_uri = "GetHostedPaymentStatus";		
	}else{
		$data = array(
				  "orderId"=> $OrderId,
				  "clientIp"=> getenv('REMOTE_ADDR'),
				  "clientUserAgent"=> $_SERVER['HTTP_USER_AGENT'],
				);
		$status_uri = "GetHostedPartialPaymentStatus";		
	}	
 
	$data = json_encode($data);
 	
	if($sanalposAyarlari['islemTipi']){
		$url = "https://api.mobilexpress.com.tr/api/".$status_uri;
		$MerchantCode = $sanalposAyarlari['MerchantCode'];
		$Authorization = $sanalposAyarlari['AuthorizationLive'];
	}else{
		$url = "https://test.mobilexpress.com.tr/api/".$status_uri;
		$MerchantCode = $sanalposAyarlari['MerchantCode'];
		$Authorization = $sanalposAyarlari['AuthorizationTest'];
	}
	$ch = curl_init();
	curl_setopt($ch, CURLOPT_POST,1);
	curl_setopt($ch, CURLOPT_URL,$url);
	curl_setopt($ch, CURLOPT_SSL_VERIFYHOST,  FALSE);
	curl_setopt($ch, CURLOPT_RETURNTRANSFER,1);
	curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, FALSE);
	curl_setopt($ch, CURLOPT_POSTFIELDS, $data);
	curl_setopt($ch, CURLOPT_TIMEOUT, 30);
	curl_setopt($ch, CURLOPT_HTTPHEADER, array(
		 "MerchantCode: ".$MerchantCode,
		"Authorization: ".$Authorization,
		"Content-Type: application/json",
	  ));
	$result=curl_exec ($ch);
	$order->add_order_note( "Ödeme Sonuç Detayları: <br>".$result );
	$result = json_decode($result,TRUE);
	$instrumentType = $result["paymentList"][0]["instrumentType"];
	$recommendedUIMessageTR = $result["paymentList"][0]["resultCategory"]["recommendedUIMessageTR"];
	if($instrumentType !="NewCard"){
		WC()->session->set( 'redirectURL', NULL );
	}
	 
	if($result["paymentResult"] == "Success"){
		$data = array();
		
		if(count($result["paymentList"])>0){
		
			$paymentList = $result["paymentList"][0];
		  $data["TaksitSayisi"] = $paymentList["installmentCount"];
		  $data["SiparisTutar"] = number_format($paymentList["amountRequested"],2,".","");
		  $data["ToplamTutar"] = number_format($paymentList["amountProcessed"],2,".","");
		  $data["VadeFarki"] = number_format($data["ToplamTutar"]-$data["SiparisTutar"],2,".","");
		  $data["SystemTransId"] = $paymentList["systemTransId"];
		  $data["BankaOnayKodu"] = $paymentList["acquirerResultDetail"]["pos"]["authCode"];
		  $data["OdemeYapilanPos"] = $paymentList["acquirerResultDetail"]["pos"]["posBankName"];
		  $data["POSID"] = $paymentList["acquirerResultDetail"]["pos"]["posId"];
		  $data["BankaTransId"] = $paymentList["acquirerResultDetail"]["pos"]["transId"];
		  $data["KartNumarasi"] = $paymentList["instrumentDetail"]["card"]["maskedCardNumber"];
		  $data["cardHolderNameFromBank"] = $paymentList["acquirerResultDetail"]["pos"]["cardHolderNameFromBank"];
		}else{
 		  	$data["ToplamTutar"] = number_format($result["processInfo"]["totalAmountProcessed"],2,".","");
 			$data["orderId"] = $result["processInfo"]["orderId"];
		}
	  
	  $paymentLog = "";
	  foreach($data as $Key=>$Value){
		  $paymentLog .=$Key ." : ".$Value."<br>";
	  }
	  	  
	  if($data["TaksitSayisi"]>1){
			
 			$tutar = $order->get_total();
			$amount = $data["ToplamTutar"];
			
			
			$vade_farki = $amount-$tutar;			
			$item_fee = new WC_Order_Item_Fee();
			$item_fee->set_name( "Vade Farkı" );
			$item_fee->set_amount( $vade_farki );
			$item_fee->set_total( $vade_farki );
			$item_fee->set_tax_class( 0 );
			$order->add_item( $item_fee );
			$order->calculate_totals();
			$order->save();
			
			}
		$order->add_order_note( "Ödeme onay bekliyor. <br>Ödeme işlem Detayları: <br>".$paymentLog );
 		$order->update_status($sanalposAyarlari['siparisDurumu']);
 		global $woocommerce;
		$woocommerce->cart->empty_cart();
		$link = $order->get_checkout_order_received_url();
		echo '<script>window.top.location.href = "' . $link . '";</script>';
		exit();
				  
	}else{
 	  $BankMessage = "Ödeme başarısız. Lütfen yeniden deneyiniz. Hata mesajı: ".$result["paymentResult"]." - ".$recommendedUIMessageTR;
	  $order->add_order_note('Mobilexpress Log: Time: '.date("Y-m-d H:i:s"). ' - OrderId:'.$OrderId.' - URL: '.$url.' - Result: ' . $result["result"]. " - ResultDetail:".$result["resultDetail"]." - ResultMessage:".$result["resultMessage"]. " - PaymentResult:".$result["paymentResult"]." - recommendedUIMessageTR: ".$recommendedUIMessageTR);
	  $returnUrl = $checkout_payment_url."&ErrorMessage=".$BankMessage;
	  echo '<script>window.top.location.href = "' . $returnUrl . '";</script>';
	}
?>